--- old/usr/src/cmd/cmd-inet/sbin/netstrategy/netstrategy.c	Sat Sep 12 00:41:12 2015
+++ new/usr/src/cmd/cmd-inet/sbin/netstrategy/netstrategy.c	Sat Sep 12 00:41:12 2015
@@ -22,9 +22,9 @@
 /*
  * Copyright 2008 Sun Microsystems, Inc.  All rights reserved.
  * Use is subject to license terms.
+ * Copyright 2015 Nexenta Systems, Inc. All rights reserved.
  */
 
-#pragma ident	"%Z%%M%	%I%	%E% SMI"
 
 /*
  * This program does the following:
@@ -36,7 +36,7 @@
  * b) If the program is successful, it prints three tokens to
  *    stdout: <root fs type> <interface name> <net config strategy>.
  *    where:
- *	<root fs type>		-	"nfs" or "ufs"
+ *	<root fs type>		-	"nfs", "ufs" or "zfs"
  *	<interface name>	-	"hme0" or "none"
  *	<net config strategy>	-	"dhcp", "rarp", "bootprops"
  *					or "none"
@@ -308,14 +308,14 @@
 	 * "ufs rarp" (consumers are coded to deal with this reality), so
 	 * there are three possible situations:
 	 *
-	 *	1. We're "ufs dhcp" if there are any interfaces which have
-	 *	   obtained their addresses through DHCP.  That is, if there
-	 *	   are any IFF_UP and non-IFF_VIRTUAL interfaces also have
-	 *	   IFF_DHCPRUNNING set.
+	 *	1. We're either "ufs dhcp" or "zfs dhcp" if there are any
+	 *	   interfaces which have obtained their addresses through DHCP.
+	 *	   That is, if there are any IFF_UP and non-IFF_VIRTUAL
+	 *	   interfaces also have IFF_DHCPRUNNING set.
 	 *
-	 *	2. We're "ufs none" if our filesystem is local and there
-	 *	   are no interfaces which have obtained their addresses
-	 *	   through DHCP.
+	 *	2. We're either "ufs none" or "zfs none" if our filesystem
+	 *	   is local and there are no interfaces which have obtained
+	 *	   their addresses through DHCP.
 	 *
 	 *	3. We're "nfs rarp" if our filesystem is remote and there's
 	 *	   at least IFF_UP non-IFF_VIRTUAL interface (which there
@@ -329,7 +329,7 @@
 	if (dhcp_running)
 		strategy = "dhcp";
 
-	if (strcmp(root, "nfs") == 0 || strcmp(root, "cachefs") == 0) {
+	if (strcmp(root, "nfs") == 0) {
 		if (interface == NULL) {
 			(void) fprintf(stderr,
 			    "%s: cannot identify root interface.\n", program);
--- old/usr/src/cmd/fs.d/Makefile	Sat Sep 12 00:41:12 2015
+++ new/usr/src/cmd/fs.d/Makefile	Sat Sep 12 00:41:12 2015
@@ -19,6 +19,7 @@
 # CDDL HEADER END
 #
 # Copyright (c) 1990, 2010, Oracle and/or its affiliates. All rights reserved.
+# Copyright 2015 Nexenta Systems, Inc. All rights reserved.
 #
 
 # The filesystem independent utilities clri, fsdb, dcopy, labelit, and mkfs
@@ -39,7 +40,7 @@
 include ../Makefile.cmd
 
 SUBDIR1= lofs zfs
-SUBDIR2= dev fd pcfs nfs hsfs proc ctfs udfs ufs tmpfs cachefs \
+SUBDIR2= dev fd pcfs nfs hsfs proc ctfs udfs ufs tmpfs \
 		autofs mntfs objfs sharefs smbclnt reparsed
 SUBDIRS= $(SUBDIR1) $(SUBDIR2)
 I18NDIRS= $(SUBDIR2)
--- old/usr/src/cmd/fs.d/autofs/autod_nfs.c	Sat Sep 12 00:41:12 2015
+++ new/usr/src/cmd/fs.d/autofs/autod_nfs.c	Sat Sep 12 00:41:12 2015
@@ -97,8 +97,6 @@
 
 #define	MAXHOSTS	512
 
-#define	MNTTYPE_CACHEFS "cachefs"
-
 /*
  * host cache states
  */
@@ -131,7 +129,7 @@
 static struct cache_entry *cache_head = NULL;
 rwlock_t cache_lock;	/* protect the cache chain */
 
-static enum nfsstat nfsmount(struct mapfs *, char *, char *, int, int, uid_t,
+static enum nfsstat nfsmount(struct mapfs *, char *, char *, int, uid_t,
 	action_list *);
 static int is_nfs_port(char *);
 
@@ -236,7 +234,6 @@
 {
 	struct mapfs *mfs, *mp;
 	int err = -1;
-	int cached;
 	action_list *alp;
 	char *dir;
 
@@ -278,10 +275,9 @@
 		}
 	}
 	if (err) {
-		cached = strcmp(me->map_mounter, MNTTYPE_CACHEFS) == 0;
 		dir = strdup(mfs->mfs_dir);
 		err = nfsmount(mfs, mntpnt, me->map_mntopts,
-		    cached, overlay, uid, alp);
+		    overlay, uid, alp);
 		if (err && trace > 1) {
 			trace_prt(1, "  Couldn't mount %s:%s, err=%d\n",
 			    mfs->mfs_host ? mfs->mfs_host : "",
@@ -639,7 +635,7 @@
 nfsmount(
 	struct mapfs *mfs_in,
 	char *mntpnt, char *opts,
-	int cached, int overlay,
+	int overlay,
 	uid_t uid,
 	action_list *alp)
 {
@@ -715,13 +711,6 @@
 			    mntpnt);
 		replicated = 0;
 	}
-	if (replicated && cached) {
-		if (verbose)
-			syslog(LOG_WARNING,
-		    "mount on %s is cached and will not be replicated.",
-			    mntpnt);
-		replicated = 0;
-	}
 	if (replicated)
 		loglevel = LOG_WARNING;
 	else
@@ -1180,50 +1169,6 @@
 		if (trace > 4 && replicated)
 			trace_prt(1, "	nfsmount: examining %s\n", remname);
 
-		/*
-		 * If it's cached we need to get cachefs to mount it.
-		 */
-		if (cached) {
-			char *copts = opts;
-
-			/*
-			 * If we started with a URL we need to turn on
-			 * -o public if not on already
-			 */
-			if (use_pubfh == FALSE &&
-			    (mfs->mfs_flags & MFS_FH_VIA_WEBNFS)) {
-
-				copts = malloc(strlen(opts) +
-				    strlen(",public")+1);
-
-				if (copts == NULL) {
-					syslog(LOG_ERR, "nfsmount: no memory");
-					last_error = NFSERR_IO;
-					goto out;
-				}
-
-				strcpy(copts, opts);
-
-				if (strlen(copts) != 0)
-					strcat(copts, ",");
-
-				strcat(copts, "public");
-			}
-
-			last_error = mount_generic(remname, MNTTYPE_CACHEFS,
-			    copts, mntpnt, overlay);
-
-			if (copts != opts)
-				free(copts);
-
-			if (last_error) {
-				skipentry = 1;
-				mfs->mfs_ignore = 1;
-				continue;
-			}
-			goto out;
-		}
-
 		if (mfs->mfs_args == NULL) {
 
 			/*
--- old/usr/src/cmd/fs.d/autofs/autod_parse.c	Sat Sep 12 00:41:13 2015
+++ new/usr/src/cmd/fs.d/autofs/autod_parse.c	Sat Sep 12 00:41:13 2015
@@ -23,6 +23,7 @@
  *
  *	Copyright 2008 Sun Microsystems, Inc.  All rights reserved.
  *	Use is subject to license terms.
+ *      Copyright 2015 Nexenta Systems, Inc. All rights reserved.
  */
 
 #include <stdio.h>
@@ -561,8 +562,6 @@
 	return (rc);
 }
 
-#define	BACKFSTYPE "backfstype" /* used in cachefs options */
-#define	BACKFSTYPE_EQ "backfstype="
 #define	FSTYPE "fstype"
 #define	FSTYPE_EQ "fstype="
 #define	NO_OPTS ""
@@ -608,33 +607,6 @@
 	strcpy(mounter,	fstype);
 
 	/*
-	 * The following ugly chunk of code crept in as a result of
-	 * cachefs.  If it's a cachefs mount of an nfs filesystem, then
-	 * it's important to parse the nfs special field.  Otherwise,
-	 * just hand the special field to the fs-specific mount
-	 */
-	if (strcmp(fstype, MNTTYPE_CACHEFS) ==  0) {
-		struct mnttab m;
-		char *p;
-
-		m.mnt_mntopts = entryopts;
-		if ((p = hasmntopt(&m, BACKFSTYPE)) != NULL) {
-			int len = strlen(MNTTYPE_NFS);
-
-			p += strlen(BACKFSTYPE_EQ);
-
-			if (strncmp(p, MNTTYPE_NFS, len) ==  0 &&
-			    (p[len] == '\0' || p[len] == ',')) {
-				/*
-				 * Cached nfs mount
-				 */
-				(void) strcpy(fstype, MNTTYPE_NFS);
-				(void) strcpy(mounter, MNTTYPE_CACHEFS);
-			}
-		}
-	}
-
-	/*
 	 * child options are exactly fstype = somefs, we need to do some
 	 * more option pushing work.
 	 */
@@ -664,9 +636,9 @@
  * and the option string with the fstype
  * option removed, e.g.
  *
- *  input:  "fstype=cachefs,ro,nosuid"
+ *  input:  "fstype=nfs,ro,nosuid"
  *  opts:   "ro,nosuid"
- *  fstype: "cachefs"
+ *  fstype: "nfs"
  *
  * Also indicates if the fstype option was present
  * by setting a flag, if the pointer to the flag
@@ -710,7 +682,6 @@
 fstype_opts(struct mapent *me, char *opts, char *defaultopts,
 				char *mapopts)
 {
-	char pushopts[AUTOFS_MAXOPTSLEN];
 	char pushentryopts[AUTOFS_MAXOPTSLEN];
 	char pushfstype[MAX_FSLEN];
 
@@ -726,16 +697,11 @@
 		if (*mapopts == '-')
 			mapopts++;
 		get_opts(mapopts, pushentryopts, pushfstype, NULL);
-		strcpy(pushopts, mapopts);
 	} else {
 		get_opts(defaultopts, pushentryopts, pushfstype, NULL);
-		strcpy(pushopts, defaultopts);
 	}
 
-	if (strcmp(pushfstype, MNTTYPE_CACHEFS) == 0)
-		me->map_mntopts = strdup(pushopts);
-	else
-		me->map_mntopts = strdup(pushentryopts);
+	me->map_mntopts = strdup(pushentryopts);
 
 	if (!me->map_mntopts) {
 		syslog(LOG_ERR, "fstype_opts: No memory");
@@ -1989,35 +1955,10 @@
 	}
 	exlist = texlist;
 
-	/*
-	 * The following ugly chunk of code crept in as
-	 * a result of cachefs.  If it's a cachefs mount
-	 * of an nfs filesystem, then have it handled as
-	 * an nfs mount but have cachefs do the mount.
-	 */
 	(void) strcpy(fstype, MNTTYPE_NFS);
 	get_opts(mapopts, entryopts, fstype, NULL);
 	(void) strcpy(mounter, fstype);
-	if (strcmp(fstype, MNTTYPE_CACHEFS) == 0) {
-		struct mnttab m;
-		char *p;
 
-		m.mnt_mntopts = entryopts;
-		if ((p = hasmntopt(&m, "backfstype")) != NULL) {
-			int len = strlen(MNTTYPE_NFS);
-
-			p += 11;
-			if (strncmp(p, MNTTYPE_NFS, len) == 0 &&
-			    (p[len] == '\0' || p[len] == ',')) {
-				/*
-				 * Cached nfs mount
-				 */
-				(void) strcpy(fstype, MNTTYPE_NFS);
-				(void) strcpy(mounter, MNTTYPE_CACHEFS);
-			}
-		}
-	}
-
 	/* Now create a mapent from the export list */
 	ms = NULL;
 	me = NULL;
--- old/usr/src/cmd/fs.d/autofs/automount.h	Sat Sep 12 00:41:13 2015
+++ new/usr/src/cmd/fs.d/autofs/automount.h	Sat Sep 12 00:41:13 2015
@@ -20,7 +20,7 @@
  */
 
 /*
- * Copyright 2014 Nexenta Systems, Inc.  All rights reserved.
+ * Copyright 2015 Nexenta Systems, Inc.  All rights reserved.
  */
 
 /*
@@ -140,7 +140,7 @@
  */
 struct mapent {
 	char	*map_fstype;	/* file system type e.g. "nfs" */
-	char	*map_mounter;	/* base fs e.g. "cachefs" */
+	char	*map_mounter;	/* base fs */
 	char	*map_root;	/* path to mount root */
 	char	*map_mntpnt;	/* path from mount root */
 	char	*map_mntopts;	/* mount options */
--- old/usr/src/cmd/fs.d/df.xcl	Sat Sep 12 00:41:19 2015
+++ new/usr/src/cmd/fs.d/df.xcl	Sat Sep 12 00:41:19 2015
@@ -85,7 +85,6 @@
 msgid  " %s"
 msgid  "/sbin/sh"
 msgid  "yes"
-msgid  "cachefs"
 msgid  "fork"
 msgid  "exec"
 msgid  "r+b"
--- old/usr/src/cmd/fs.d/mount.c	Sat Sep 12 00:41:19 2015
+++ new/usr/src/cmd/fs.d/mount.c	Sat Sep 12 00:41:19 2015
@@ -27,7 +27,7 @@
  * Use is subject to license terms.
  */
 /*
- * Copyright 2012 Nexenta Systems, Inc.  All rights reserved.
+ * Copyright 2015 Nexenta Systems, Inc.  All rights reserved.
  */
 
 #include	<stdio.h>
@@ -139,15 +139,6 @@
 int	aflg, cflg, fflg, Fflg, gflg, oflg, pflg, rflg, vflg, Vflg, mflg, Oflg,
 	dashflg, questflg, dflg, qflg;
 
-/*
- * Currently, mounting cachefs instances simultaneously uncovers various
- * problems.  For the short term, we serialize cachefs activity while we fix
- * these cachefs bugs.
- */
-#define	CACHEFS_BUG
-#ifdef	CACHEFS_BUG
-int	cachefs_running;	/* parallel cachefs not supported yet */
-#endif
 
 /*
  * Each vfsent_t describes a vfstab entry.  It is used to manage and cleanup
@@ -1295,15 +1286,6 @@
 		while (nrun >= maxrun && (dowait() != -1))	/* throttle */
 			;
 
-#ifdef	CACHEFS_BUG
-		if (vp->v.vfs_fstype &&
-		    (strcmp(vp->v.vfs_fstype, "cachefs") == 0)) {
-			while (cachefs_running && (dowait() != -1))
-				;
-			cachefs_running = 1;
-		}
-#endif
-
 		if ((child = fork()) == -1) {
 			perror("fork");
 			cleanup(-1);
@@ -1474,11 +1456,6 @@
 			lofsfail++;
 	}
 
-#ifdef CACHEFS_BUG
-	if (vp->v.vfs_fstype && (strcmp(vp->v.vfs_fstype, "cachefs") == 0))
-		cachefs_running = 0;
-#endif
-
 	vp->exitcode = ret;
 	return (ret);
 }
--- old/usr/src/cmd/fs.d/nfs/nfsstat/nfsstat.c	Sat Sep 12 00:41:19 2015
+++ new/usr/src/cmd/fs.d/nfs/nfsstat/nfsstat.c	Sat Sep 12 00:41:19 2015
@@ -25,6 +25,7 @@
 /*
  * Copyright 2009 Sun Microsystems, Inc.  All rights reserved.
  * Use is subject to license terms.
+ * Copyright 2015 Nexenta Systems, Inc. All rights reserved.
  */
 
 /*
@@ -1115,33 +1116,9 @@
 		list = mrp;
 	}
 
-	/*
-	 * If something got ignored, go to the beginning of the mnttab
-	 * and look for the cachefs entries since they are the one
-	 * causing this. The mount point saved for the ignored entries
-	 * is matched against the special to get the actual mount point.
-	 * We are interested in the acutal mount point so that the output
-	 * look nice too.
-	 */
-	if (ignored) {
-		rewind(mt);
-		resetmnttab(mt);
-		while (getextmntent(mt, &m, sizeof (struct extmnttab)) == 0) {
+	(void) fclose(mt);
 
-			/* ignore non "cachefs" */
-			if (strcmp(m.mnt_fstype, MNTTYPE_CACHEFS) != 0)
-				continue;
-
-			for (mrp = list; mrp; mrp = mrp->next) {
-				if (mrp->ig_path == 0)
-					continue;
-				if (strcmp(mrp->ig_path, m.mnt_special) == 0) {
-					mrp->ig_path = 0;
-					(void) strcpy(mrp->my_dir,
-					    m.mnt_mountp);
-				}
-			}
-		}
+	if (ignored) {
 		/*
 		 * Now ignored entries which do not have
 		 * the my_dir initialized are really ignored; This never
@@ -1157,9 +1134,6 @@
 		}
 	}
 
-	(void) fclose(mt);
-
-
 	for (ksp = kc->kc_chain; ksp; ksp = ksp->ks_next) {
 		int i;
 
--- old/usr/src/cmd/fs.d/nfs/share/fstypes	Sat Sep 12 00:41:20 2015
+++ new/usr/src/cmd/fs.d/nfs/share/fstypes	Sat Sep 12 00:41:20 2015
@@ -1,4 +1,3 @@
 nfs NFS Utilities
 autofs AUTOFS Utilities
-cachefs CACHEFS Utilities
 smbfs CIFS Utilities
--- old/usr/src/cmd/fs.d/nfs/svc/nfs-client	Sat Sep 12 00:41:20 2015
+++ new/usr/src/cmd/fs.d/nfs/svc/nfs-client	Sat Sep 12 00:41:20 2015
@@ -23,8 +23,8 @@
 #
 # Copyright 2004 Sun Microsystems, Inc.  All rights reserved.
 # Use is subject to license terms.
+# Copyright 2015 Nexenta Systems, Inc. All rights reserved.
 #
-#ident	"%Z%%M%	%I%	%E% SMI"
 
 #
 # Start/stop client NFS service
@@ -34,7 +34,6 @@
 
 stop_nfsclnt()
 {
-	/sbin/umountall -F cachefs
 	/sbin/umountall -F nfs
 }
 
@@ -42,7 +41,6 @@
 'start')
 
 	/sbin/mountall -F nfs
-	/sbin/mountall -F cachefs
 	/sbin/swapadd
 	;;
 
--- old/usr/src/cmd/fs.d/umount.c	Sat Sep 12 00:41:20 2015
+++ new/usr/src/cmd/fs.d/umount.c	Sat Sep 12 00:41:20 2015
@@ -21,6 +21,7 @@
 /*
  * Copyright 2010 Sun Microsystems, Inc.  All rights reserved.
  * Use is subject to license terms.
+ * Copyright 2015 Nexenta Systems, Inc. All rights reserved.
  */
 
 /*	Copyright (c) 1984, 1986, 1987, 1988, 1989 AT&T	*/
@@ -79,17 +80,6 @@
 static  char ibuf[BUFSIZ];
 
 /*
- * Currently, mounting cachefs's simultaneous uncovers various problems.
- * For the short term, we serialize cachefs activity while we fix
- * these cachefs bugs.
- */
-#define	CACHEFS_BUG
-#ifdef	CACHEFS_BUG
-#include	<sys/fs/cachefs_fs.h>	/* for BACKMNT_NAME */
-int	cachefs_running;	/* parallel cachefs not supported yet */
-#endif
-
-/*
  * The basic mount struct that describes an mnttab entry.
  * It is used both in an array and as a linked list elem.
  */
@@ -818,23 +808,6 @@
 		while (nrun >= maxrun && (dowait() != -1))	/* throttle */
 			;
 
-#ifdef CACHEFS_BUG
-		/*
-		 * If this is the back file system, then let cachefs/umount
-		 * unmount it.
-		 */
-		if (strstr(mp->ment.mnt_mountp, BACKMNT_NAME))
-			continue;
-
-
-		if (mp->ment.mnt_fstype &&
-		    (strcmp(mp->ment.mnt_fstype, "cachefs") == 0)) {
-			while (cachefs_running && (dowait() != -1))
-					;
-			cachefs_running = 1;
-		}
-#endif
-
 		if ((pid = fork()) == -1) {
 			perror("fork");
 			cleanup(-1);
@@ -944,12 +917,6 @@
 	    (strcmp(mp->ment.mnt_fstype, MNTTYPE_LOFS) == 0))
 		lofscnt--;
 
-#ifdef CACHEFS_BUG
-	if (mp->ment.mnt_fstype &&
-	    (strcmp(mp->ment.mnt_fstype, "cachefs") == 0))
-		cachefs_running = 0;
-#endif
-
 	return (ret);
 }
 
--- old/usr/src/cmd/initpkg/init.d/Makefile	Sat Sep 12 00:41:20 2015
+++ new/usr/src/cmd/initpkg/init.d/Makefile	Sat Sep 12 00:41:20 2015
@@ -32,7 +32,6 @@
 
 PROG=		\
 	README		\
-	cachefs.daemon	\
 	sysetup		\
 	uucp		\
 	$($(MACH)_PROG)
--- old/usr/src/cmd/initpkg/mountall.sh	Sat Sep 12 00:41:21 2015
+++ new/usr/src/cmd/initpkg/mountall.sh	Sat Sep 12 00:41:21 2015
@@ -24,6 +24,7 @@
 #
 # Copyright 2009 Sun Microsystems, Inc.  All rights reserved.
 # Use is subject to license terms.
+# Copyright 2015 Nexenta Systems, Inc. All rights reserved.
 #
 #	Copyright (c) 1984, 1986, 1987, 1988, 1989 AT&T
 #	  All Rights Reserved
@@ -409,7 +410,7 @@
 	exit
 fi
 
-# Some remote filesystems (e.g. cachefs or autofs) shouldn't be be mounted
+# Some remote filesystems (e.g. autofs) shouldn't be mounted
 # with mountall, so the list here is explicit (not from /etc/dfs/fstypes)
 if [ "$RFLAG" ]; then
 	/sbin/mount -a -F nfs
--- old/usr/src/cmd/initpkg/rc2.d/mk.rc2.d.sh	Sat Sep 12 00:41:21 2015
+++ new/usr/src/cmd/initpkg/rc2.d/mk.rc2.d.sh	Sat Sep 12 00:41:21 2015
@@ -23,12 +23,12 @@
 #	  All Rights Reserved
 #
 # Copyright (c) 1988, 2010, Oracle and/or its affiliates. All rights reserved.
+# Copyright 2015 Nexenta Systems, Inc. All rights reserved.
 #
 
 COMMON_STARTLST="\
 20sysetup \
-70uucp \
-73cachefs.daemon"
+70uucp"
 
 INSDIR=${ROOT}/etc/rc2.d
 
--- old/usr/src/cmd/stmsboot/mpxio-upgrade	Sat Sep 12 00:41:21 2015
+++ new/usr/src/cmd/stmsboot/mpxio-upgrade	Sat Sep 12 00:41:21 2015
@@ -21,6 +21,7 @@
 #
 #
 # Copyright (c) 2004, 2010, Oracle and/or its affiliates. All rights reserved.
+# Copyright 2015 Nexenta Systems, Inc. All rights reserved.
 #
 
 . /lib/svc/share/fs_include.sh
@@ -173,59 +174,39 @@
 			;;
 		esac
 		
-		if [ "$fstype" = "cachefs" ]; then
-			# Mount read-only without the cache.
-			case "$mntopts" in
-			*backfstype=nfs*)
-				cfsbacktype=nfs
-				;;
-			*backfstype=hsfs*)
-				cfsbacktype=hsfs
-				;;
-			*)
-				cecho 'stmsboot: invalid vfstab entry for /usr'
-				cfsbacktype=nfs
-				;;
-			esac
-			# see the comment below for /dev/null
-			$MOUNT -m -F $cfsbacktype -o ro $new_special $mountp \
->/dev/null 2>&1
-			ret_val=$?
+		#
+		# Must use -o largefiles here to ensure the read-only
+		# mount does not fail as a result of having a large
+		# file present on /usr.
+		#
+		if [ "$mntopts" = "-" ]; then
+			mntopts='ro,largefiles'
 		else
-			#
-			# Must use -o largefiles here to ensure the read-only
-			# mount does not fail as a result of having a large
-			# file present on /usr.
-			#
-			if [ "$mntopts" = "-" ]; then
-				mntopts='ro,largefiles'
-			else
-				checkopt largefiles $mntopts
-				if [ "$option" != "largefiles" ]; then
-					mntopts="largefiles,$mntopts"
-				fi
+			checkopt largefiles $mntopts
+			if [ "$option" != "largefiles" ]; then
+				mntopts="largefiles,$mntopts"
+			fi
 
-				checkopt ro $mntopts
-				if [ "$option" != "ro" ]; then
-					mntopts="ro,$mntopts"
-				fi
+			checkopt ro $mntopts
+			if [ "$option" != "ro" ]; then
+				mntopts="ro,$mntopts"
+			fi
 
-				# Requesting logging on a read-only mount
-				# causes errors to be displayed, so remove
-				# "logging" from the list of options.
-				checkopt logging $mntopts
-				if [ "$option" = "logging" ]; then
-					mntopts="$otherops"
-				fi
+			# Requesting logging on a read-only mount
+			# causes errors to be displayed, so remove
+			# "logging" from the list of options.
+			checkopt logging $mntopts
+			if [ "$option" = "logging" ]; then
+				mntopts="$otherops"
 			fi
+		fi
 
-			# In case of a manual restart of the service, mount
-			# will emit messages if /usr is already mounted.
-			# So redirect the output to /dev/null.
-			$MOUNT -m -F $fstype -o $mntopts $new_special /usr \
+		# In case of a manual restart of the service, mount
+		# will emit messages if /usr is already mounted.
+		# So redirect the output to /dev/null.
+		$MOUNT -m -F $fstype -o $mntopts $new_special /usr \
 >/dev/null 2>&1
-			ret_val=$?
-		fi
+		ret_val=$?
 		if [ $ret_val -eq 0 ]; then
 			usrmounted=1
 		fi
--- old/usr/src/cmd/stmsboot/stmsboot.sh	Sat Sep 12 00:41:21 2015
+++ new/usr/src/cmd/stmsboot/stmsboot.sh	Sat Sep 12 00:41:21 2015
@@ -21,6 +21,7 @@
 #
 #
 # Copyright (c) 2004, 2010, Oracle and/or its affiliates. All rights reserved.
+# Copyright 2015 Nexenta Systems, Inc. All rights reserved.
 #
 #
 PATH=/usr/bin:/usr/sbin:$PATH; export PATH
@@ -549,12 +550,8 @@
 
 
 if [ "$cmd" = "enable" -o "$cmd" = "disable" -o "$cmd" = "update" ]; then
-	#
-	# The bootup script doesn't work on cache-only-clients as the script
-	# is executed before the plumbing for cachefs mounting of root is done.
-	#
-	if $MOUNT -v | $EGREP -s " on / type (nfs|cachefs) "; then
-		gettext "This command option is not supported on systems with an nfs or cachefs mounted root filesystem.\n" 1>&2
+	if $MOUNT -v | $EGREP -s " on / type nfs "; then
+		gettext "This command option is not supported on systems with an nfs mounted root filesystem.\n" 1>&2
 		exit 1
 	fi
 
--- old/usr/src/cmd/svc/shell/smf_include.sh	Sat Sep 12 00:41:21 2015
+++ new/usr/src/cmd/svc/shell/smf_include.sh	Sat Sep 12 00:41:21 2015
@@ -22,6 +22,7 @@
 #
 # Copyright 2009 Sun Microsystems, Inc.  All rights reserved.
 # Use is subject to license terms.
+# Copyright 2015 Nexenta Systems, Inc. All rights reserved.
 #
 
 smf_present () {
@@ -134,7 +135,7 @@
 
 	set -- `/sbin/netstrategy`
 	if [ $? -eq 0 ]; then
-		[ "$1" = "nfs" -o "$1" = "cachefs" ] && \
+		[ "$1" = "nfs" ] && \
 			_INIT_NET_IF="$2" export _INIT_NET_IF
 		_INIT_NET_STRATEGY="$3" export _INIT_NET_STRATEGY
 	else
--- old/usr/src/cmd/svr4pkg/libinst/mntinfo.c	Sat Sep 12 00:41:22 2015
+++ new/usr/src/cmd/svr4pkg/libinst/mntinfo.c	Sat Sep 12 00:41:22 2015
@@ -22,6 +22,7 @@
 /*
  * Copyright 2009 Sun Microsystems, Inc.  All rights reserved.
  * Use is subject to license terms.
+ * Copyright 2015 Nexenta Systems, Inc. All rights reserved.
  */
 
 
@@ -105,11 +106,6 @@
 
 #define	HOST_NM_LN	MNT_LINE_MAX
 
-/* These cachefs definitions should be in mntent.h. Maybe some day. */
-#define	MNTTYPE_CFS		"cachefs"
-#define	MNTOPT_BACKFSTYPE	"backfstype"
-#define	MNTTYPE_AUTO		"autofs"
-
 /*
  * Utilities for getting filesystem information from the mount table.
  *
@@ -227,7 +223,7 @@
 	if (n < fs_tab_used) {
 		(void) strcpy(hostname, fs_tab[n]->remote_name);
 		if ((host_end = strchr(hostname, ':')) == NULL) {
-			if ((strcmp(fs_tab[n]->fstype, MNTTYPE_AUTO)) == NULL)
+			if ((strcmp(fs_tab[n]->fstype, MNTTYPE_AUTOFS)) == NULL)
 				return ("automounter");
 			else
 				return (fs_tab[n]->fstype);
@@ -714,7 +710,7 @@
 	 * allowed to mount ourself with "NFS", "NFS" must be remote.
 	 * The automount will translate "nfs:self" to a lofs mount.
 	 */
-	if (strcmp(mt->mnt_fstype, MNTTYPE_AUTO) == 0 ||
+	if (strcmp(mt->mnt_fstype, MNTTYPE_AUTOFS) == 0 ||
 	    strcmp(mt->mnt_fstype, MNTTYPE_NFS) == 0 ||
 	    is_remote_src(mt->mnt_special) == REAL_REMOTE)
 		nfte->remote = 1;
@@ -963,9 +959,6 @@
 				/*
 				 * We also skip the entry if the vfs_special
 				 * path and the client_path are the same.
-				 * There's no need to mount it, it's just a
-				 * cachefs optimization that mounts a
-				 * directory over itself from this server.
 				 */
 				if ((is_remote == SELF_SERVE) &&
 				    strcmp(path_part(vfs->vfs_special),
--- old/usr/src/lib/libefi/common/rdwr_efi.c	Sat Sep 12 00:41:22 2015
+++ new/usr/src/lib/libefi/common/rdwr_efi.c	Sat Sep 12 00:41:22 2015
@@ -21,7 +21,7 @@
 
 /*
  * Copyright (c) 2002, 2010, Oracle and/or its affiliates. All rights reserved.
- * Copyright 2012 Nexenta Systems, Inc.  All rights reserved.
+ * Copyright 2015 Nexenta Systems, Inc.  All rights reserved.
  * Copyright 2014 Toomas Soome <tsoome@me.com>
  */
 
@@ -55,7 +55,7 @@
 	{ EFI_VAR },
 	{ EFI_HOME },
 	{ EFI_ALTSCTR },
-	{ 0 },			/* CACHE (cachefs) is never used */
+	{ 0 },			/* CACHE is never used */
 	{ EFI_RESERVED },
 	{ EFI_SYSTEM },
 	{ EFI_LEGACY_MBR },
--- old/usr/src/lib/libpkg/common/isdir.c	Sat Sep 12 00:41:22 2015
+++ new/usr/src/lib/libpkg/common/isdir.c	Sat Sep 12 00:41:22 2015
@@ -22,6 +22,7 @@
 /*
  * Copyright 2004 Sun Microsystems, Inc.  All rights reserved.
  * Use is subject to license terms.
+ * Copyright 2015 Nexenta Systems, Inc. All rights reserved.
  */
 
 /* Copyright (c) 1984, 1986, 1987, 1988, 1989 AT&T */
@@ -345,10 +346,9 @@
 	if ((fp = fopen(REMOTE_FS_DBFILE, "r")) == NULL) {
 		/* no remote type database: use predefined remote types */
 		remoteFstypes = (char **)realloc(remoteFstypes,
-					sizeof (char *) * (numRemoteFstypes+3));
+		    sizeof (char *) * (numRemoteFstypes+2));
 		remoteFstypes[numRemoteFstypes++] = "nfs";	/* +1 */
 		remoteFstypes[numRemoteFstypes++] = "autofs";	/* +2 */
-		remoteFstypes[numRemoteFstypes++] = "cachefs";	/* +3 */
 		return;
 	}
 
@@ -365,7 +365,6 @@
 	 *
 	 *	nfs NFS Utilities
 	 *	autofs AUTOFS Utilities
-	 *	cachefs CACHEFS Utilities
 	 */
 
 	while (fgets(line_buf, sizeof (line_buf), fp) != NULL) {
@@ -375,13 +374,13 @@
 		if (format[0] == '\0') {
 			/* create bounded format: %ns */
 			(void) snprintf(format, sizeof (format),
-				"%%%ds", sizeof (buf)-1);
+			    "%%%ds", sizeof (buf)-1);
 		}
 
 		(void) sscanf(line_buf, format, buf);
 
 		remoteFstypes = realloc(remoteFstypes,
-					sizeof (char *) * (numRemoteFstypes+1));
+		    sizeof (char *) * (numRemoteFstypes+1));
 		remoteFstypes[numRemoteFstypes++] = strdup(buf);
 	}
 
--- old/usr/src/lib/libzonecfg/common/libzonecfg.c	Sat Sep 12 00:41:22 2015
+++ new/usr/src/lib/libzonecfg/common/libzonecfg.c	Sat Sep 12 00:41:22 2015
@@ -22,6 +22,7 @@
 /*
  * Copyright 2014 Gary Mills
  * Copyright (c) 2003, 2010, Oracle and/or its affiliates. All rights reserved.
+ * Copyright 2015 Nexenta Systems, Inc. All rights reserved.
  */
 
 #include <libsysevent.h>
@@ -5817,8 +5818,7 @@
 	if (strcmp(type, "proc") == 0 ||
 	    strcmp(type, "mntfs") == 0 ||
 	    strcmp(type, "autofs") == 0 ||
-	    strncmp(type, "nfs", sizeof ("nfs") - 1) == 0 ||
-	    strcmp(type, "cachefs") == 0)
+	    strncmp(type, "nfs", sizeof ("nfs") - 1) == 0)
 		return (B_FALSE);
 	/*
 	 * The caller may do more detailed verification to make sure other
--- old/usr/src/lib/lvm/libmeta/common/meta_check.c	Sat Sep 12 00:41:23 2015
+++ new/usr/src/lib/lvm/libmeta/common/meta_check.c	Sat Sep 12 00:41:23 2015
@@ -22,6 +22,7 @@
 /*
  * Copyright 2009 Sun Microsystems, Inc.  All rights reserved.
  * Use is subject to license terms.
+ * Copyright 2015 Nexenta Systems, Inc. All rights reserved.
  */
 
 /*
@@ -66,7 +67,6 @@
 	"autofs",
 	"proc",
 	"tmpfs",
-	"cachefs",
 	"rfs",
 	"fd",
 	"mntfs",
--- old/usr/src/lib/lvm/libmeta/common/meta_mount.c	Sat Sep 12 00:41:24 2015
+++ new/usr/src/lib/lvm/libmeta/common/meta_mount.c	Sat Sep 12 00:41:24 2015
@@ -21,9 +21,9 @@
 /*
  * Copyright 2006 Sun Microsystems, Inc.  All rights reserved.
  * Use is subject to license terms.
+ * Copyright 2015 Nexenta Systems, Inc. All rights reserved.
  */
 
-#pragma ident	"%Z%%M%	%I%	%E% SMI"
 
 /*
  * return mount association with meta device
@@ -73,7 +73,6 @@
 		    (strcmp(m.mnt_fstype, "autofs") == 0) ||
 		    (strcmp(m.mnt_fstype, "proc") == 0) ||
 		    (strcmp(m.mnt_fstype, "tmpfs") == 0) ||
-		    (strcmp(m.mnt_fstype, "cachefs") == 0) ||
 		    (strcmp(m.mnt_fstype, "lofs") == 0) ||
 		    (strcmp(m.mnt_fstype, "rfs") == 0) ||
 		    (strcmp(m.mnt_fstype, "fd") == 0))
--- old/usr/src/man/man1m/Intro.1m	Sat Sep 12 00:41:24 2015
+++ new/usr/src/man/man1m/Intro.1m	Sat Sep 12 00:41:24 2015
@@ -1,10 +1,11 @@
 '\" te
 .\" Copyright 2008, Sun Microsystems, Inc. All Rights Reserved.
+.\" Copyright 2015 Nexenta Systems, Inc. All rights reserved. 
 .\" Copyright 1989 AT&T
 .\" The contents of this file are subject to the terms of the Common Development and Distribution License (the "License").  You may not use this file except in compliance with the License.
 .\" You can obtain a copy of the license at usr/src/OPENSOLARIS.LICENSE or http://www.opensolaris.org/os/licensing.  See the License for the specific language governing permissions and limitations under the License.
 .\" When distributing Covered Code, include this CDDL HEADER in each file and include the License file at usr/src/OPENSOLARIS.LICENSE.  If applicable, add the following below this CDDL HEADER, with the fields enclosed by brackets "[]" replaced with your own identifying information: Portions Copyright [yyyy] [name of copyright owner]
-.TH INTRO 1M "Nov 17, 2008"
+.TH INTRO 1M "Sep 8, 2015"
 .SH NAME
 Intro, intro \- introduction to maintenance commands and application programs
 .SH DESCRIPTION
@@ -17,8 +18,8 @@
 Because of command restructuring for the Virtual File System architecture,
 there are several instances of multiple manual pages that begin with the same
 name. For example, the   \fBmount\fR, pages \(mi \fBmount\fR(1M),
-\fBmount_cachefs\fR(1M), \fBmount_hsfs\fR(1M), \fBmount_nfs\fR(1M), \fB
-mount_tmpfs\fR(1M), and \fBmount_ufs\fR(1M). In each such case the first of the
+\fBmount_hsfs\fR(1M), \fBmount_nfs\fR(1M), \fBmount_tmpfs\fR(1M),
+and \fBmount_ufs\fR(1M). In each such case the first of the
 multiple pages describes the syntax and options of the generic command, that
 is, those options applicable to all FSTypes (file system types). The succeeding
 pages describe the functionality of the FSType-specific modules of the command.
--- old/usr/src/man/man1m/Makefile	Sat Sep 12 00:41:24 2015
+++ new/usr/src/man/man1m/Makefile	Sat Sep 12 00:41:24 2015
@@ -12,7 +12,7 @@
 #
 # Copyright 2011, Richard Lowe
 # Copyright (c) 2012, Joyent, Inc.  All rights reserved.
-# Copyright 2013 Nexenta Systems, Inc.  All rights reserved.
+# Copyright 2015 Nexenta Systems, Inc.  All rights reserved.
 #
 
 include		$(SRC)//Makefile.master
@@ -53,11 +53,6 @@
 		bootadm.1m		\
 		bootconfchk.1m		\
 		busstat.1m		\
-		cachefsd.1m		\
-		cachefslog.1m		\
-		cachefspack.1m		\
-		cachefsstat.1m		\
-		cachefswssize.1m	\
 		captoinfo.1m		\
 		catman.1m		\
 		cfgadm.1m		\
@@ -71,7 +66,6 @@
 		cfgadm_scsi.1m		\
 		cfgadm_sysctrl.1m	\
 		cfgadm_usb.1m		\
-		cfsadmin.1m		\
 		chat.1m			\
 		check-hostname.1m	\
 		check-permissions.1m	\
@@ -141,7 +135,6 @@
 		format.1m		\
 		fruadm.1m		\
 		fsck.1m			\
-		fsck_cachefs.1m		\
 		fsck_pcfs.1m		\
 		fsck_udfs.1m		\
 		fsck_ufs.1m		\
@@ -325,7 +318,6 @@
 		modload.1m		\
 		modunload.1m		\
 		mount.1m		\
-		mount_cachefs.1m	\
 		mount_hsfs.1m		\
 		mount_nfs.1m		\
 		mount_pcfs.1m		\
